package src.core;

import java.util.ArrayList;

import src.mlp.NetworkConfigs;
import src.mlp.PatternSymbol;
import src.treeController.TreeController;

/*Classe que comanda o treinamento e o reconhecimento.*/
public class ClassifierController {
	private static int symbolLength;
	private static int numberOfClasses;
	private TreeController reconhecedor;	

	public double run(ArrayList <PatternSymbol> trainingSymbols, ArrayList <PatternSymbol> recognizingSymbols, int totalClasses){
		symbolLength= trainingSymbols.get(0).getSymbol().length;
		int hiddenLayerSize = 50;
		numberOfClasses = totalClasses;		
		NetworkConfigs netSize = new NetworkConfigs(symbolLength,hiddenLayerSize,numberOfClasses); 
		reconhecedor = new TreeController(netSize);
		
		long initialTime = System.currentTimeMillis();
		reconhecedor.trainAll(trainingSymbols);
		long trainingTime = System.currentTimeMillis();
		double recognitionRate = reconhecedor.recognizeAll(recognizingSymbols);
		long endTime = System.currentTimeMillis();
		 
		System.out.println("Tempo de treinamento: "+ (trainingTime - initialTime)/1000+" segundos.");
		System.out.println("Tempo de reconhecimento: "+ (endTime - trainingTime)+" milissegundos.");
		return recognitionRate;
	}	


}
