package src.core;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.StringTokenizer;
import java.util.Vector;

import src.distort.Pair;

/*Classe que l os arquivos de entrada escritos pelos voluntrios.*/
public class InputFileReader {

	private boolean isFirstPoint;
	private boolean isTrash = true;
	private static String filePath;	
	private Vector <Sample> sampleList= new Vector <Sample>();
	private int symbolNumber = -1;
	private int writerNumber = 0;
	private int numberOfStrokes = 0;	
	private int previousX;
	private int previousY;
	
	
	public Vector<Sample> readFile ( ){	
		int line = 0;		
		filePath = System.getProperty("user.dir");
		String os = System.getProperty("os.name");
		if(os.startsWith("Windows"))
			filePath = filePath.concat("\\data\\writers\\");
		else
			filePath = filePath.concat("/data/writers/");
		File diretorio = new File(filePath);
		File [] arquivos = diretorio.listFiles();
		
		for(int i=0;i<10;i++){			
			Sample newSample = new Sample();
			sampleList.add(newSample);
		}
		
		for(int indice=0;indice<arquivos.length;indice++){
			String nomeUsuario = arquivos[indice].getName();
			sampleList.get(indice).name=nomeUsuario;
			String arquivo = filePath.concat(nomeUsuario);
//			System.out.println("i vale: "+indice);
//			System.out.println("vai tentar abrir o arquivo: "+arquivo);
			try {
				BufferedReader in = new BufferedReader(new FileReader(arquivo));
				String str;
				while ((str = in.readLine()) != null) {
					line++;
					processLine(str);
				}
				in.close();
			}
			catch (IOException e) {				
				e.printStackTrace();
				System.out.println("Por favor insira um nome de arquivo vlido");				
			}
			writerNumber++;
			symbolNumber = -1;
		}
		return sampleList;
	}
	
	private void processLine(String linha){
		//System.out.println("processaLinha: "+linha);
		StringTokenizer st = new StringTokenizer(linha, " ");
		
		if(st.hasMoreTokens() == false)
			return;
		String primeiro =st.nextToken();
		//System.out.println("primeiro token da linha: "+primeiro);
		//System.out.println("lixo: "+lixo);
		if(isTrash){
			if(primeiro.equals(".SEGMENT")){				
				isTrash = false;
				processSymbol(linha);
				
			}
			return;
		}
		processSymbol(linha);		
	}
	
	
	private void processSymbol(String linha ){
		Sample writer = sampleList.get(writerNumber);
		PointList symbol = null;
		StringTokenizer st = new StringTokenizer(linha, " ");
		if(st.hasMoreTokens()==false)
			return;
		String firstToken = st.nextToken();		
		if(firstToken.equals(".SEGMENT")){
			processSEGMENT(writerNumber);
			return;
		}
		else if(firstToken.equals(".END_FILE")){
			symbol = writer.symbols.get(symbolNumber);
			symbol.setXFim(previousX);
			symbol.setYFim(previousY);
			symbol.updateFeatures();
			return;
		}
		else if(firstToken.equals(".PEN_DOWN") ){
			numberOfStrokes ++;
			writer.symbols.get(symbolNumber).increaseStrokesNumber();
			return;
		}
		else if (firstToken.equals(".PEN_UP") ){			
			Pair naoInterpolavel = new Pair(-10000,-10000);
			writer.symbols.get(symbolNumber).getList().add(naoInterpolavel);			
			return;
		}
		else if ( firstToken.equals(".DT") || firstToken.equals(".COMMENT"))
			return;
		else			
		symbol = writer.symbols.get(symbolNumber);		
		String secondToken = st.nextToken();						
		int x = Integer.parseInt(firstToken);
		int y = Integer.parseInt(secondToken);		
		updateMinMax(x,y,symbol);		
		/*Os ultimos pontos so sempre os atuais.*/
		previousX = x;
		previousY = y;		
		if(isFirstPoint){			
			symbol.setXIni(x);
			symbol.setYIni(y);
			isFirstPoint = false;
		}		
		symbol.getList().add(new Pair(x,y));		
	}
	private void processSEGMENT(int writerNumber){
		Sample userNumber = sampleList.get(writerNumber);
		isFirstPoint = true;		
		PointList symbol = new PointList();		
		userNumber.symbols.add(symbol);		
		if(symbolNumber > -1 ){			
			PointList listaAnterior = userNumber.symbols.get(symbolNumber);
			listaAnterior.setXFim(previousX);
			listaAnterior.setYFim(previousY);
			listaAnterior.updateFeatures();
		}
		symbolNumber++;
	}	
	
	private void updateMinMax (int x, int y, PointList symbol){
		if(x <symbol.getXMin())			
			symbol.setXMin(x);			
		if(x >symbol.getXMax())
			symbol.setXMax(x);			
		if(y <symbol.getYMin())
			symbol.setYMin(y);		
		if(y >symbol.getYMax())
			symbol.setYMax(y);			
	}
}
