package src.distort;

import src.core.PointList;
import src.core.Matrix;

/*Classe que centraliza e expande o smbolo para que ocupe toda a matriz.*/
public class Normalizer {
	
	/*Move a lista de pontos para o centro da matriz.*/
	private PointList moveToTheCenter(PointList original){
		Pair center = new Pair((original.getXMax()+original.getXMin())/2,(original.getYMax()+original.getYMin())/2);
		Matrix toGetMeasures = new Matrix();
		Pair matrixCenter = new Pair(toGetMeasures.theMatrix[0].length/2,toGetMeasures.theMatrix.length/2);
		return move(original,-(center.getX()-matrixCenter.getX()),-(center.getY()-matrixCenter.getY()));
	}
	
	private PointList move(PointList original,int deslocamentoHorizontal, int deslocamentoVertical){
		PointList nova = new PointList(original);
		nova.getList().removeAllElements();
		nova.setXMax(original.getXMax()+deslocamentoHorizontal);
		nova.setXMin(original.getXMin()+ deslocamentoHorizontal);
		nova.setYMax(original.getYMax()+deslocamentoVertical);
		nova.setYMin(original.getYMin()+ deslocamentoVertical);
		for(int i =0;i<original.getList().size();i++){
			Pair atual = original.getList().get(i);
			int novoX = atual.getX()+deslocamentoHorizontal;
			int novoY = atual.getY()+deslocamentoVertical;
			Pair novo = new Pair(novoX,novoY);
			nova.getList().add(novo);
		}		
		return nova;		
	}
	
	public PointList fillTheWholeMatrix(PointList original){
		Matrix m = new Matrix();
		int superiorGap = original.getYMin();
		int inferiorGap = m.theMatrix.length-original.getYMax();		
		int leftGap = original.getXMin();
		int rightGap = m.theMatrix[0].length-original.getXMax();		
		int verticalGap = superiorGap + inferiorGap;
		int horizontalGap = leftGap + rightGap;
		original = moveToTheCenter(original);
		Stretcher s = new Stretcher();
		double verticalIntensity   = Math.pow(verticalGap,   3);
		double horizontalIntensity = Math.pow(horizontalGap, 3);
		if(verticalGap<horizontalGap){			
				original = s.stretch(verticalIntensity, verticalIntensity,  original);			
		}else{	
				original = s.stretch(horizontalIntensity, horizontalIntensity,  original);
		}		
		return original;	
	}	
}
