package src.distort;

import src.core.PointList;
import src.util.Random;

/*Classe que simula a caneta tremendo ao escrever no papel*/
public class Shaker {
	private Random randomizer = new Random();
	
	private int calculateDistance(Pair um, Pair dois){
		double distx = um.getX()-dois.getX();
		double disty = um.getY() -dois.getY();
		return (int)Math.round(Math.sqrt( Math.pow(distx, 2)+ Math.pow(disty,2 )));		
	}	
	
	public PointList interpolate (PointList pl){
		return interpolate(0,pl.getList().size()-1,pl);
	}
	
	public PointList interpolate (int begin, int end, PointList pl){
		//System.out.println("novo interpola. inicio= "+begin+" fim =" +end+" lista tem tamanho: "+pl.getList().size());
		PointList nova = new PointList(pl);		
		int xAnt;
		int xMeio;
		int xPos;
		int yAnt;
		int yMeio;
		int yPos;
		Pair ant;
		Pair meio;
		Pair pos;
		for(int i=begin;i<end;i++){			
			ant =pl.getList().get(i);
			xAnt = ant.getX();
			yAnt = ant.getY();
			if(ant.getX() >0 && ant.getY() >0){
				pos =pl.getList().get(i+1);
				if(pos.getX() >0 && pos.getY() >0 && calculateDistance(ant,pos)<50){
					xPos = pos.getX();
					yPos = pos.getY();
					xMeio = (xAnt+xPos)/2;
					yMeio = (yAnt+yPos)/2;
					meio = new Pair(xMeio,yMeio);
					nova.getList().add(ant);
					if(meio.getX()!=xAnt || meio.getY()!=yAnt)
						nova.getList().add(meio);					
				}
			}
		}		
		return nova;
	}
	
	/*Simula a caneta tremendo ao escrever no papel.*/
	public PointList shake (PointList original){
		long totalShakes = randomizer.randomNumber(30,60); /*Executa um nmero aleatrio de "tremidas" entre 30 e 60*/		
		int shakesDone =0;
		for (int shakeNumber=0;shakeNumber<totalShakes;shakeNumber++){			
			long shakeRadius = randomizer.randomNumber(5,8);
			long shakePoint = randomizer.randomNumber((int) shakeRadius+1, (int)(original.getList().size()-(shakeRadius +25)));
			long shakeIntensity = randomizer.randomNumber(10, 30);
			int shakeStart = (int) (shakePoint-shakeRadius);
			int shakeEnd = (int) (shakePoint+shakeRadius);
			Pair ant = original.getList().get(shakeStart);
			Pair pos = original.getList().get(shakeEnd);
			Pair atual = ant;
			
			int distanciaParaRemocao = (int)randomizer.randomNumber(5,15);
			while(calculateDistance(atual,ant)<distanciaParaRemocao){
				int indiceAtual = original.getList().indexOf(atual);
				if(indiceAtual+1 >= original.getList().size())
					break;
				Pair prox = original.getList().get(indiceAtual+1);				
				original.getList().removeElementAt(indiceAtual);
				atual = prox;
			}			
			int randomNumber = randomizer.randomSign((int)randomizer.randomNumber(0,(int)shakeIntensity)) ;
			int novoX = (ant.getX()+pos.getX())/2 +randomNumber;
			randomNumber = randomizer.randomSign((int)randomizer.randomNumber(0,(int)shakeIntensity)) ;
			int novoY = (ant.getY()+pos.getY())/2+randomNumber;
			Pair novoPar = new Pair(novoX,novoY);
			original.getList().insertElementAt(novoPar,(int)(shakePoint-shakeRadius));
			shakesDone ++;			
			original = interpolate(shakeStart, shakeEnd, original);
		}
		return original;		
	}
	
	
}
