package src.mlp;
import src.mlp.activationFunctions.IActivationFunction;

/*Cada unidade da rede neural simula o funcionamento de um neurnio.*/
public class Perceptron {
	private int thisPerceptronNumber;
	private double sum = 0;
	private double output;
	private IActivationFunction activationFunction;
	
	public double perceptronOutput(double [] previousLayerOutput, WeightLayer incomingWeight){
		int i;
		sum = 0;		
		for(i=0 ; i < previousLayerOutput.length-1 ; i++ ){			
			sum += previousLayerOutput[i]*incomingWeight.getWeight(i,thisPerceptronNumber);			
		}
		/*Como o valor do vis  sempre fixo, a unidade no precisa receb-lo. 
		 *Da o numero 1 abaixo*/
		sum += 1 * incomingWeight.getWeight(i,thisPerceptronNumber);
		output = activationFunction.evaluate(sum);
		return output;		
	}		
	
	public Perceptron (IActivationFunction activationFunction , int thisPerceptronNumber){
		this.thisPerceptronNumber = thisPerceptronNumber;
		this.activationFunction = activationFunction;
	}
}
