package src.mlp;
import src.mlp.activationFunctions.IActivationFunction;

/*Classe que representa uma camada de unidades da rede neural.*/
public class PerceptronLayer {
	
	private Perceptron [] perceptronArray ;
	private double [] output ;
	
	public PerceptronLayer(int numberOfPerceptrons, IActivationFunction activationFunction){
		perceptronArray = new Perceptron[numberOfPerceptrons+1];
		output = new double [numberOfPerceptrons+1];
		for (int i =0; i<numberOfPerceptrons; i++){
			perceptronArray[i]=new Perceptron(activationFunction, i);
		}
		output[numberOfPerceptrons]=1;
	}	

	
	public void produceOutput (double [] inputForThisLayer, WeightLayer weights){
		for (int i = 0 ; i< size()-1  ; i++ ){			
			output[i] = perceptronArray[i].perceptronOutput(inputForThisLayer, weights);			
		}
	}
	
	public double getOutput(int i){
		return output[i];	
	}
	
	public double[] getOutput(){
		return output;
	}
	
	public int size (){
		return perceptronArray.length;
	}


	public Perceptron[] getPerceptron() {
		return perceptronArray;
	}


	public void setPerceptron(Perceptron[] perceptron) {
		this.perceptronArray = perceptron;
	}


	public void setOutput(double[] output) {
		this.output = output;
	}
	
	
}
